<?php
defined( 'ABSPATH' ) || exit;

function word_balloon_post_page() {

	global $wpdb;
	$table_name = $wpdb->prefix . 'word_balloon';
	$array = $wpdb->get_results("SELECT * FROM $table_name", 'ARRAY_A');


	
	require_once WORD_BALLOON_DIR . 'inc/default_settings.php';

	$load_setting = word_balloon_default_settings('load_setting');
	$atts = word_balloon_default_settings('atts');

	$easy_mode = '';

	if($load_setting['easy_mode'] != 'false'){
		$easy_mode = ' style="display: none;"';
	}

	if(!empty($load_setting['disable_balloon'])){
		foreach ($load_setting['disable_balloon'] as $key => $value) {
			if($value === 'true')unset($load_setting['type_balloon'][$key]);
		}
	}

	$load_setting['enable_icon'] = $load_setting['enable_effect'] = $load_setting['enable_filter'] = false;

	if(!empty($load_setting['disable_balloon'])){
		foreach ($load_setting['disable_icon'] as $key => $value) {
			if($value === 'true'){
				unset($load_setting['type_icon'][$key]);
			}else{
				$load_setting['enable_icon'] = true;
			}
		}
	}else{
		$load_setting['enable_icon'] = true;
	}

	if(!empty($load_setting['disable_effect'])){
		foreach ($load_setting['disable_effect'] as $key => $value) {
			if($value === 'true'){
				unset($load_setting['type_effect'][$key]);
			}else{
				$load_setting['enable_effect'] = true;
			}
		}
	}else{
		$load_setting['enable_effect'] = true;
	}

	if(!empty($load_setting['disable_filter'])){
		foreach ($load_setting['disable_filter'] as $key => $value) {
			if($value === 'true'){
				unset($load_setting['type_filter'][$key]);
			}else{
				$load_setting['enable_filter'] = true;
			}
		}
	}else{
		$load_setting['enable_filter'] = true;
	}
	?>
	<button type="button" id="w_b_modal_open" class="button" data-target="w_b_modal1" style="display: none;"></button>
	<div id="w_b_overlay" style="display: none;">
		<div class="w_b_container">
			<div class="w_b_inner">
				<div class="w_b_modal">
					<div class="w_b_modal_close_box"><button type="button" class="w_b_modal_close"><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" aria-hidden="true" width="64" height="64" preserveAspectRatio="xMidYMid meet" viewBox="0 0 304 384"><path d="M299 73L179 192l120 119-30 30-120-119L30 341 0 311l119-119L0 73l30-30 119 119L269 43z" fill="#626262"/></svg></button></div>
					<div class="w_b_easy_mode_contents w_b_flex_box w_b_ai_c w_b_jc_sb">
						<input type="hidden" id="w_b_wordballoon_url" data-w_b_url="<?php echo WORD_BALLOON_URI; ?>" />
						<h2 class="w_b_flex_box" style="margin:0;"><i class="wb-comment" aria-hidden="true" style="margin-right:5px"></i> <?php _e('Insert of word balloon','word-balloon'); ?></h2>
						<div class="w_b_flex_box w_b_ai_c w_b_tooltip" data-tooltip="<?php _e('Restore','word-balloon'); ?>" style="white-space: nowrap;">
							<i id="w_b_do_restore" class="wb-undo" aria-hidden="true" style="font-size:20px;color:#ddd;"></i>
						</div>
						<div class="w_b_flex_box w_b_ai_c">
							<label for="w_b_easy_mode" class="w_b_contents_side_heading"><?php _e('Easy mode','word-balloon'); ?></label>
							<div class="w_b_checkbox">
								<input type="checkbox" id="w_b_easy_mode" name="w_b_easy_mode"<?php checked( $load_setting['easy_mode'], 'true' ); ?> />
								<label for="w_b_easy_mode"></label>
							</div>
						</div>
					</div>
					<div class="w_b_box_pre_load" style="margin-bottom: -10px;padding:0 10px 0;">
						<?php $textarea = '<textarea rows="5" cols="60" name="balloon_quote" placeholder="'.__('Place avatar\'s message here','word-balloon').'" id="w_b_post_text" style="border: 0px solid transparent;box-shadow: none;resize: both;background:transparent;max-width:390px;height:41px;width:calc(100% - 45px);line-height:1.2;scrollbar-base-color: transparent;padding:2px 10px 2px 6px"></textarea>';
						echo word_balloon_build_balloon( $atts , '' , '' , $textarea);  ?>
					</div>

					<form class="w_b_avatar_select_form" name="w_b_avatar_select_form">


						<div class="w_b_flex_box w_b_ai_c w_b_main_select_box">

							<div class="w_b_flex_box w_b_ai_c" style="max-width: 165px;">
								<label for="w_b_avatar_select" class="w_b_contents_side_heading"><i class="wb-user" aria-hidden="true"></i></label>
								<select name="w_b_avatar_select" style="width:100%;" id="w_b_avatar_select">

									<?php

									if($load_setting['avatar_priority'] === 'true'){

                                        
										foreach ($array as $key => $value) {
											$priority[$key] = $value['priority'];
										}

                                        
                                        
										array_multisort($priority, SORT_ASC, $array);

									}

									foreach($array as $key => $value){
										echo '<option value="'.$value['id'].'" data-avatar_name="'.$value['name'].'" data-avatar_img="'.$value['url'].'">'.$value['name'].($value['text'] != "" ?  ' ('.$value['text'].')' : '').'</option>';
									}


									if (empty($array) || $load_setting['keep_mystery_men'] === 'true') {
										echo '<option value="mystery_men" data-avatar_name="'.__('Mystery Men','word-balloon').'" data-avatar_img="'.WORD_BALLOON_URI . 'img/mystery_men.svg'.'">'.__('Mystery Men(mysterious figure)','word-balloon').'</option>';
									}
									?>
								</select>



							</div>

							<div class="w_b_flex_box w_b_ai_c">


								<div class="w_b_radiobox">
									<input id="avatar_position_L" type="radio" name="post_avatar_position" value="L"<?php checked( $load_setting['avatar_position'], 'L' ); ?> class="w_b_radio" data-post_avatar_position="L" />
									<label for="avatar_position_L"><i class="wb-arrow-left" aria-hidden="true"></i></label>
								</div>

								<input id="w_b_box_center" type="checkbox" name="box_center" <?php checked( $load_setting['box_center'], 'true' ); ?> style="display:none" />
								<label for="w_b_box_center" class="w_b_crosshairs w_b_contents_side_heading w_b_box_center" style="margin: 0 8px;"><i class="wb-crosshairs" aria-hidden="true" style="font-size: 24px;"></i></label>


								<div class="w_b_radiobox">
									<input id="avatar_position_R" type="radio" name="post_avatar_position" value="R"<?php checked( $load_setting['avatar_position'], 'R' ); ?> class="w_b_radio" data-post_avatar_position="R" />
									<label for="avatar_position_R"><i class="wb-arrow-right" aria-hidden="true"></i></label>
								</div>

							</div>

							<div class="w_b_flex_box w_b_ai_c">
								<label for="w_b_choice_balloon" class="w_b_contents_side_heading"><i class="wb-comment-o" aria-hidden="true"></i></label>
								<select id="w_b_choice_balloon" name="post_choice_balloon" class="change_choice_balloon">
									<?php
									foreach ($load_setting['type_balloon'] as $key => $value) {
										echo '<option value="'.$key.'"';
										selected( $load_setting['choice_balloon'], $key );
										echo '>'.$value.'</option>';
									}
									?>
								</select>
							</div>

							<?php if($load_setting['side_by_side'] !== 'false'){ ?>
								<div class="w_b_flex_box w_b_ai_c" >
									<label><i class="wb-comments w_b_side_by_side_submit" aria-hidden="true" style="font-size: 24px;"></i></label>
								</div>
							<?php } ?>

							<div class="w_b_flex_box w_b_ai_c" style="margin-left:auto">
								<input type="button" class="button button-primary" id="w_b_avatar_data_submit" value="<?php _e('Insert','word-balloon'); ?>" onclick="return false;" />
							</div>

						</div>



						<div class="w_b_flex_box w_b_ai_c w_b_avatar_template_wrap">

							<?php

							if(array_filter($load_setting['favorite'])){
								$favorite_enable = false;
								$i = 1;
								while($i < 6){
									if(isset($load_setting['favorite'][$i]['enable'])){
										if($load_setting['favorite'][$i]['enable'] === 'true'){
											$favorite_enable = true;
											$favorite_data = '';
											foreach ($load_setting['favorite'][$i] as $key => $value) {
												$favorite_data .= ' data-'.$key.'="'.$value.'"';
											}
											echo '<input type="hidden" id="w_b_favorite_'.$i.'" '.$favorite_data.' />';
										}
									}
									++$i;
								}
								if($favorite_enable){
									?>
									<div class="w_b_avatar_template_box">
										<select name="w_b_favorite">
											<option value="" selected><?php _e('Favorite','word-balloon'); ?></option>
											<?php
											$i = 1;
											while($i < 6){
												if(!empty($load_setting['favorite'][$i])){
													if($load_setting['favorite'][$i]['enable'] === 'true'){
														echo '<option value="'.$i.'">'.$i.' '.$load_setting['favorite'][$i]['memo'].'</option>';
													}
												}
												++$i;
											}
											?>
										</select>
									</div>

									<?php
								}
							}


							if(array_filter($load_setting['template'])){
								?>
								<div class="w_b_avatar_template_box">
									<select name="w_b_template">
										<option value="" selected><?php _e('Template','word-balloon'); ?></option>
										<?php
										$i = 1;
										while($i < 6){
											if(!empty($load_setting['template'][$i])){
												echo '<option value="'.$load_setting['template'][$i].'">'.$load_setting['template'][$i].'</option>';
											}
											++$i;
										}
										?>
									</select>
								</div>

								<?php
							}
							?>




							<?php
							$wallpaper = "";
							$i = 1;
							while($i < 6){
								$wallpaper_background_color = $wallpaper_image = $wallpaper_border_color = "";
								if(!empty($load_setting['wallpaper'][$i]["background_color"])) $wallpaper_background_color = $load_setting['wallpaper'][$i]["background_color"];
								if(!empty($load_setting['wallpaper'][$i]["image"])) $wallpaper_image = $load_setting['wallpaper'][$i]["image"];
								if(!empty($load_setting['wallpaper'][$i]["border_color"])) $wallpaper_border_color = $load_setting['wallpaper'][$i]["border_color"];

								if( $wallpaper_background_color != "" ||  $wallpaper_image != "" ){
									$wallpaper .= '<input type="button" class="w_b_wallpaper_submit button" name="wallpaper_'.$i.'" value="'.$i.'" style="background-color:'.$wallpaper_background_color.';border-color:'.$wallpaper_border_color.';background-image:url('.$wallpaper_image.');background-size:auto 30px;" data-wallpaper_number="'.$i.'" />';
								}
								++$i;
							}
							if($wallpaper != ''){
								echo '<div class="w_b_flex_box w_b_ai_c w_b_jc_sb w_b_wallpaper_warp"><label class="w_b_contents_side_heading" style="cursor: initial;"><i class="wb-image" aria-hidden="true"></i> '.__('Wallpaper','word-balloon').'</label>'. $wallpaper . '</div>';
							}
							?>





						</div>



						<div class="w_b_avatar_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['avatar'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
							<span class="w_b_contents_title"><i class="wb-user" aria-hidden="true"></i> <?php _e('Avatar','word-balloon'); ?></span>

							<div class="w_b_flex_box w_b_jc_sb">





								<div class="w_b_avatar_sub_contents">
									<label class="w_b_contents_side_heading"><i class="wb-expand" aria-hidden="true"></i> <?php _e('Size','word-balloon'); ?></label><br>
									<select id="w_b_select_avatar_size" name="avatar_size" class="change_avatar_size">
										<option value="S"<?php selected( $load_setting['avatar_size'], 'S' ); ?>>
											<?php _e('Small','word-balloon'); ?>
										</option>
										<option value="M"<?php selected( $load_setting['avatar_size'], 'M' ); ?>>
											<?php _e('Medium','word-balloon'); ?>
										</option>
										<option value="L"<?php selected( $load_setting['avatar_size'], 'L' ); ?>>
											<?php _e('Large','word-balloon'); ?>
										</option>
									</select>
									<input type="hidden" name="avatar_custom_size[S]" value="<?php echo esc_attr( $load_setting['avatar_custom_size']['S'] ); ?>" id="w_b_avatar_custom_size_S" />
									<input type="hidden" name="avatar_custom_size[M]" value="<?php echo esc_attr( $load_setting['avatar_custom_size']['M'] ); ?>" id="w_b_avatar_custom_size_M" />
									<input type="hidden" name="avatar_custom_size[L]" value="<?php echo esc_attr( $load_setting['avatar_custom_size']['L'] ); ?>" id="w_b_avatar_custom_size_L" />
								</div>

								<div class="w_b_avatar_sub_contents">
									<label class="w_b_contents_side_heading"><i class="wb-refresh" aria-hidden="true"></i> <?php _e('Flip','word-balloon'); ?></label>

									<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">
										<label for="w_b_avatar_flip_h" style=""><?php _e('Horizontal','word-balloon'); ?></label>
										<div class="w_b_checkbox">
											<input type="checkbox" id="w_b_avatar_flip_h" name="avatar_flip_h" />
											<label for="w_b_avatar_flip_h"></label>
										</div>
									</div>
									<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">
										<label for="w_b_avatar_flip_v" style=""><?php _e('Vertical','word-balloon'); ?></label>
										<div class="w_b_checkbox">
											<input type="checkbox" id="w_b_avatar_flip_v" name="avatar_flip_v" />
											<label for="w_b_avatar_flip_v"></label>
										</div>
									</div>

								</div>

								<div class="w_b_avatar_sub_contents">


									<div class="w_b_flex_box w_b_flex_column">
										<div class="w_b_flex_box w_b_ai_c">
											<label class="w_b_contents_side_heading" for="w_b_avatar_border_radius"><i class="wb-square-o" aria-hidden="true"></i> <?php _e('Rounded corners','word-balloon'); ?></label>
										</div>

										<select id="w_b_avatar_border_radius" name="avatar_border_radius">
											<?php
											foreach ($load_setting['type_radius'] as $key => $value) {
												echo '<option value="'.$key.'"';
												selected( $load_setting['avatar_border_radius'], $key );
												echo '>'.$value.'</option>';
											}
											?>
										</select>

									</div>

								</div>

								<div class="w_b_avatar_sub_contents">

									<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">

										<label class="" for="w_b_avatar_border"><?php _e('On border around','word-balloon'); ?></label>
										<div class="w_b_checkbox">
											<input type="checkbox" id="w_b_avatar_border" name="avatar_border" <?php checked( $load_setting['avatar_border'] , 'true'); ?> />
											<label for="w_b_avatar_border"></label>
										</div>




									</div>

									<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">

										<label class="" for="w_b_avatar_shadow"><?php _e('Shadow effect','word-balloon'); ?></label>
										<div class="w_b_checkbox">
											<input id="w_b_avatar_shadow" type="checkbox" name="avatar_shadow" <?php checked( $load_setting['avatar_shadow'] , 'true'); ?> />
											<label for="w_b_avatar_shadow"></label>
										</div>

									</div>







									<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">
										<label for="w_b_avatar_hide" style=""><?php _e('Hide avatar','word-balloon'); ?></label>
										<div class="w_b_checkbox">
											<input type="checkbox" id="w_b_avatar_hide" name="avatar_hide"<?php checked( $load_setting['avatar_hide'] , 'true'); ?> />
											<label for="w_b_avatar_hide"></label>
										</div>
									</div>

								</div>

							</div>

						</div>

						<?php
						
						require_once WORD_BALLOON_DIR . 'inc/custom_balloon_style.php';
						word_balloon_custom_balloon_style($load_setting);


						$border_style = array(
							'none' => esc_html__( 'none', 'word-balloon' ),
							'solid' => esc_html__( 'Solid', 'word-balloon' ),
							'double' => esc_html__( 'Double', 'word-balloon' ),
							'groove' => esc_html__( 'Groove', 'word-balloon' ),
							'ridge' => esc_html__( 'Ridge', 'word-balloon' ),
							'inset' => esc_html__( 'Inset', 'word-balloon' ),
							'outset' => esc_html__( 'Outset', 'word-balloon' ),
							'dashed' => esc_html__( 'Dashed', 'word-balloon' ),
							'dotted' => esc_html__( 'Dotted', 'word-balloon' ),
						);


						?>

						<div class="w_b_balloon_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['balloon'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
							<span class="w_b_contents_title"><i class="wb-comment-o" aria-hidden="true"></i> <?php _e('Balloon','word-balloon'); ?></span>


							<div class="">
								<?php /*
								<label class="w_b_contents_side_heading"><i class="wb-paint-brush" aria-hidden="true"></i> <?php _e('Color','word-balloon'); ?></label>
								*/ ?>
								<div class="w_b_flex_box">
									<div class="w_b_color_pick_wrap w_b_balloon_sub_contents">
										<div class="w_b_flex_box w_b_ai_c">
											<label class=""><?php _e('Text','word-balloon'); ?></label>
											<input type="text" name="text_color" class="w_b_color_pick" data-color_change_type="text_color" data-balloon_css="color" />
										</div>
									</div>
									<div class="w_b_color_pick_wrap w_b_balloon_sub_contents w_b_flex_box">
										<div class="w_b_flex_box w_b_ai_c">
											<label class=""><?php _e('Background','word-balloon'); ?></label>
											<input type="text" name="balloon_background" class="w_b_color_pick" data-color_change_type="balloon_background" />
										</div>
									</div>
								</div>
							</div>

							<div class="w_b_border_block">

								<label class="w_b_contents_side_heading w_b_border_label"><i class="wb-square-o" aria-hidden="true"></i> <?php _e('Border','word-balloon'); ?></label>
								<div class="w_b_flex_box w_b_ai_c">
									<div class="w_b_color_pick_wrap w_b_balloon_sub_contents">
										<div class="w_b_flex_box w_b_ai_c">
											<label class=""><?php _e('Color','word-balloon'); ?></label>
											<input type="text" name="balloon_border_color" class="w_b_color_pick" data-color_change_type="balloon_border_color" />
										</div>
									</div>

									<div class="w_b_color_pick_wrap w_b_balloon_sub_contents">
										<div class="w_b_flex_box w_b_ai_c">
											<label class=""><?php _e('Shadow Color','word-balloon'); ?></label>
											<input type="text" name="balloon_shadow_color" class="w_b_color_pick" data-color_change_type="balloon_shadow_color" />
										</div>
									</div>

									<div class="w_b_border_style_wrap w_b_balloon_sub_contents">
										<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">

											<label class=""><?php _e('Style','word-balloon'); ?></label>
											<select name="balloon_border_style" class="w_b_balloon_border_custom" data-balloon_css="border-style">
												<?php
												foreach ($border_style as $bs_key => $bs_value) {
													echo '<option value="'.$bs_key.'">'.$bs_value.'</option>';
												}
												?>
											</select>

										</div>
									</div>
									<div class="w_b_border_width_wrap w_b_balloon_sub_contents">
										<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">
											<label class="" for="w_b_custom_border_width">
												<?php _e( 'Width','word-balloon' ); ?>
											</label>
											<input type="number" name="balloon_border_width" class="w_b_balloon_border_custom" value="" data-balloon_css="border-width" id="w_b_custom_border_width" min="1" max="50" />

										</div>
									</div>
								</div>

							</div>

							<div class="w_b_balloon_sub_contents">
<?php /*
								<label class="w_b_contents_side_heading"><i class="wb-cogs" aria-hidden="true"></i> <?php _e('Option','word-balloon'); ?></label>
*/ ?>
<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">

	<div class="w_b_flex_box w_b_ai_c">
		<label class="" for="w_b_font_size"><?php _e('Font size','word-balloon'); ?></label>
		<select id="w_b_font_size" name="font_size" style="width:auto">
			<?php
			$i = 6;
			while($i<16){
				echo '<option value="'.$i.'"';
				selected( $load_setting['font_size'], $i );
				echo '>'.$i.'</option>';
				++$i;
			}
			echo '<option value=""';
			selected( $load_setting['font_size'], '' );
			echo '></option>';
			while($i<33){
				echo '<option value="'.$i.'"';
				selected( $load_setting['font_size'], $i );
				echo '>'.$i.'</option>';
				++$i;
			}
			?>
		</select>px
		<input type="hidden" name="font_size_default" value="<?php echo esc_attr( $load_setting['font_size'] ); ?>" id="w_b_font_size_default" />
	</div>


	<div class="w_b_flex_box w_b_ai_c">
		<label class="" for="w_b_text_align"><?php _e('Text alignment','word-balloon'); ?></label>
		<select id="w_b_text_align" name="text_align" style="width:auto">
			<option value="L"<?php selected( $load_setting['text_align'], 'L' ); ?>>
				<?php _e('Left','word-balloon'); ?>
			</option>
			<option value="C"<?php selected( $load_setting['text_align'], 'C' ); ?>>
				<?php _e('Center','word-balloon'); ?>
			</option>
			<option value="R"<?php selected( $load_setting['text_align'], 'R' ); ?>>
				<?php _e('Right','word-balloon'); ?>
			</option>
		</select>
		<input type="hidden" name="text_align_default" value="<?php echo esc_attr( $load_setting['text_align'] ); ?>" id="w_b_font_size_default" />
	</div>

	<div class="">
		<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">
			<label class="" for="w_b_balloon_shadow"><?php _e('Shadow effect','word-balloon'); ?></label>
			<div class="w_b_checkbox">
				<input id="w_b_balloon_shadow" type="checkbox" name="balloon_shadow"<?php checked( $load_setting['balloon_shadow'] , 'true'); ?> />
				<label for="w_b_balloon_shadow"></label>
			</div>
		</div>
		<div class="w_b_flex_box w_b_ai_c w_b_jc_sb" style="margin-top:10px;">
			<label class="" for="w_b_balloon_full_width"><?php _e('Full width','word-balloon'); ?></label>
			<div class="w_b_checkbox">
				<input id="w_b_balloon_full_width" type="checkbox" name="balloon_full_width"<?php checked( $load_setting['balloon_full_width'] , 'true'); ?> />
				<label for="w_b_balloon_full_width"></label>
			</div>
		</div>
	</div>
</div>
</div>






</div>




<?php
if($load_setting['enable_icon']): ;
	?>

	<div class="w_b_icon_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['icon'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
		<span class="w_b_contents_title"><i class="wb-smile-o" aria-hidden="true"></i> <?php _e('Icon','word-balloon'); ?></span>




		<div class="w_b_flex_box w_b_jc_sb w_b_ai_c">
			<div class="w_b_icon_sub_contents">
				<label class="w_b_contents_side_heading"><i class="wb-smile-o" aria-hidden="true"></i></label>
				<select name="w_b_icon_type">
					<option value="" selected></option>
					<?php
					foreach ($load_setting['type_icon'] as $key => $value) {
						?>
						<option value="<?php echo $key; ?>" data-icon_src="<?php echo WORD_BALLOON_URI . 'icon/'.$key.'.svg' ?>">
							<?php echo $value; ?>
						</option>
						<?php
					}
					?>
				</select>
			</div>


			<div class="w_b_icon_sub_contents">
				<div class="w_b_flex_box w_b_ai_c">
					<label class="w_b_contents_side_heading"><i class="wb-crosshairs" aria-hidden="true"></i> <?php _e('Position','word-balloon'); ?></label>
					<div class="w_b_flex_box w_b_flex_column">
						<div class="w_b_flex_box">
							<?php
							foreach ($load_setting['icon_position'] as $key => $value) {
								$arrow = 'arrow-left';
								if($key === 'center')$arrow = 'circle';
								?>
								<div class="w_b_radiobox">
									<input id="icon_position_<?php echo $key; ?>" type="radio" name="icon_position" value="<?php echo $key; ?>"<?php checked( $key, 'top_left' ); ?> class="w_b_radio" data-icon_position="<?php echo $key; ?>" />
									<label for="icon_position_<?php echo $key; ?>" class="wb_icon_<?php echo $key; ?>"><i class="wb-<?php echo $arrow; ?>" aria-hidden="true"></i></label>
								</div>
								<?php
								if($key === 'top_right'){
									echo '</div><div class="w_b_flex_box">';
								}else if($key === 'center_right'){
									echo '</div><div class="w_b_flex_box">';
								}
							} ?>
						</div>
					</div>
				</div>
			</div>

			<div class="w_b_icon_sub_contents">
				<div class="w_b_flex_box w_b_flex_column">
					<label class="w_b_contents_side_heading"><i class="wb-expand" aria-hidden="true"></i> <?php _e('Size','word-balloon'); ?></label>
					<select name="w_b_icon_size">
						<option value="S"<?php selected( $load_setting['icon_size'], 'S' ); ?>>
							<?php _e('Small','word-balloon'); ?>
						</option>
						<option value="M"<?php selected( $load_setting['icon_size'], 'M' ); ?>>
							<?php _e('Medium','word-balloon'); ?>
						</option>
						<option value="L"<?php selected( $load_setting['icon_size'], 'L' ); ?>>
							<?php _e('Large','word-balloon'); ?>
						</option>
					</select>
					<input type="hidden" name="w_b_icon_custom_size" data-size_S="<?php echo esc_attr( $load_setting['icon_custom_size']['S'] ); ?>" data-size_M="<?php echo esc_attr( $load_setting['icon_custom_size']['M'] ); ?>" data-size_L="<?php echo esc_attr( $load_setting['icon_custom_size']['L'] ); ?>" />
				</div>
			</div>

			<div class="w_b_icon_sub_contents">
				<div class="w_b_flex_box w_b_ai_c">
					<label class="w_b_contents_side_heading"><i class="wb-refresh" aria-hidden="true"></i> <?php _e('Flip','word-balloon'); ?></label>
					<div>
						<div class="w_b_flex_box w_b_ai_c w_b_jc_sb">
							<label for="w_b_icon_flip_h" style="flex: none;"><?php _e('Horizontal','word-balloon'); ?></label>
							<div class="w_b_checkbox">
								<input type="checkbox" id="w_b_icon_flip_h" name="icon_flip_h" />
								<label for="w_b_icon_flip_h"></label>
							</div>
						</div>
						<div class="w_b_flex_box w_b_ai_c w_b_jc_sb" style="margin-top:5px;">
							<label for="w_b_icon_flip_v" style="flex: none;"><?php _e('Vertical','word-balloon'); ?></label>
							<div class="w_b_checkbox">
								<input type="checkbox" id="w_b_icon_flip_v" name="icon_flip_v" />
								<label for="w_b_icon_flip_v"></label>
							</div>
						</div>
					</div>
				</div>
			</div>

		</div>

	</div>

	<?php

endif;

if($load_setting['enable_effect']): ;

	?>

	<div class="w_b_effect_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['effect'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
		<span class="w_b_contents_title"><i class="wb-magic" aria-hidden="true"></i> <?php _e('Effects','word-balloon'); ?></span>
		<div class="w_b_flex_box w_b_jc_sb">
			<div class="w_b_effect_sub_contents w_b_flex_box w_b_ai_c">
				<label class="w_b_contents_side_heading"><i class="wb-user" aria-hidden="true"></i> </label>
				<select name="w_b_avatar_effect">
					<option value="" selected></option>
					<?php
					foreach ($load_setting['type_effect'] as $key => $value) {
						?>
						<option value="<?php echo $key; ?>">
							<?php echo $value; ?>
						</option>
						<?php
					}
					?>
				</select>
			</div>

			<?php
			if($load_setting['enable_icon']): ; ?>
				<div class="w_b_effect_sub_contents w_b_flex_box w_b_ai_c">
					<label class="w_b_contents_side_heading"><i class="wb-smile-o" aria-hidden="true"></i> </label>
					<select name="w_b_icon_effect">
						<option value="" selected></option>
						<?php
						foreach ($load_setting['type_effect'] as $key => $value) {
							?>
							<option value="<?php echo $key; ?>">
								<?php echo $value; ?>
							</option>
							<?php
						}
						?>
					</select>
				</div>
			<?php endif; ?>

			<div class="w_b_effect_sub_contents w_b_flex_box w_b_ai_c">
				<label class="w_b_contents_side_heading"><i class="wb-comment-o" aria-hidden="true"></i> </label>
				<select name="w_b_balloon_effect">
					<option value="" selected></option>
					<?php
					foreach ($load_setting['type_effect'] as $key => $value) {
						?>
						<option value="<?php echo $key; ?>">
							<?php echo $value; ?>
						</option>
						<?php
					}
					?>
				</select>
				<?php
				$effect_jquery = '';
				foreach ($load_setting['type_effect'] as $key => $value) {
					$effect_jquery .= '"'.$key.'",';
				}
				?>
				<input type="hidden" id="w_b_type_effect" data-type='[<?php echo rtrim($effect_jquery , ','); ?>]' />
			</div>

		</div>



	</div>

	<?php
endif;

if($load_setting['enable_filter']): ;

	?>

	<div class="w_b_filter_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['filter'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
		<span class="w_b_contents_title"><i class="wb-filter" aria-hidden="true"></i> <?php _e('Filters','word-balloon'); ?></span>
		<div class="w_b_flex_box w_b_jc_sb">

			<div class="w_b_filter_sub_contents w_b_flex_box w_b_ai_c">
				<label class="w_b_contents_side_heading"><i class="wb-user" aria-hidden="true"></i> </label>
				<select name="w_b_avatar_filter">
					<option value="" selected></option>
					<?php
					foreach ($load_setting['type_filter'] as $key => $value) {
						?>
						<option value="<?php echo $key; ?>">
							<?php echo $value; ?>
						</option>
						<?php
					}
					?>
				</select>
			</div>

			<?php
			if($load_setting['enable_icon']): ; ?>
				<div class="w_b_filter_sub_contents w_b_flex_box w_b_ai_c">
					<label class="w_b_contents_side_heading"><i class="wb-smile-o" aria-hidden="true"></i> </label>
					<select name="w_b_icon_filter">
						<option value="" selected></option>
						<?php
						foreach ($load_setting['type_filter'] as $key => $value) {
							?>
							<option value="<?php echo $key; ?>">
								<?php echo $value; ?>
							</option>
							<?php
						}
						?>
					</select>
				</div>
			<?php endif; ?>

			<div class="w_b_filter_sub_contents w_b_flex_box w_b_ai_c">
				<label class="w_b_contents_side_heading"><i class="wb-comment-o" aria-hidden="true"></i> </label>
				<select name="w_b_balloon_filter">
					<option value="" selected></option>
					<?php
					foreach ($load_setting['type_filter'] as $key => $value) {
						?>
						<option value="<?php echo $key; ?>">
							<?php echo $value; ?>
						</option>
						<?php
					}
					?>
				</select>
				<?php
				$filter_jquery = '';
				foreach ($load_setting['type_filter'] as $key => $value) {
					$filter_jquery .= '"'.$key.'",';
				}
				?>
				<input type="hidden" id="w_b_type_filter" data-type='[<?php echo rtrim($filter_jquery , ','); ?>]' />
			</div>

		</div>



	</div>

	<?php
endif;
?>



<div class="w_b_name_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['name'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
	<span class="w_b_contents_title"><i class="wb-vcard-o" aria-hidden="true"></i> <?php _e('Name','word-balloon'); ?></span>
	<div class="w_b_flex_box w_b_jc_sb">
		<div class="w_b_name_sub_contents w_b_flex_box w_b_ai_c">
			<label class="w_b_contents_side_heading"><i class="wb-crosshairs" aria-hidden="true"></i> <?php _e('Position','word-balloon'); ?></label>
			<div>
				<select id="w_b_select_name_position" name="name_position">
					<option value="under_avatar"<?php selected( $load_setting['name_position'], 'under_avatar' ); ?>>
						<?php _e('under the avatar','word-balloon'); ?>
					</option>
					<option value="on_balloon"<?php selected( $load_setting['name_position'], 'on_balloon' ); ?>>
						<?php _e('on the balloon','word-balloon'); ?>
					</option>
					<option value="hide"<?php selected( $load_setting['name_position'], 'hide' ); ?>>
						<?php _e('hide','word-balloon'); ?>
					</option>
					<option value="on_avatar"<?php selected( $load_setting['name_position'], 'on_avatar' ); ?>>
						<?php _e('on the avatar','word-balloon'); ?>
					</option>
					<option value="under_balloon"<?php selected( $load_setting['name_position'], 'under_balloon' ); ?>>
						<?php _e('under the balloon','word-balloon'); ?>
					</option>
				</select>
			</div>
		</div>
		<div class="w_b_name_sub_contents w_b_flex_box w_b_ai_c" style="margin: 0 10px;">
			<label class="w_b_contents_side_heading"><?php _e('a display name','word-balloon'); ?></label>
			<div>
				<input type="text" id="w_b_avatar_name" name="avatar_name" class="" style="width: 100%;">
			</div>
		</div>
		<div class="w_b_name_sub_contents w_b_flex_box w_b_ai_c">
			<label class="w_b_contents_side_heading"><i class="wb-paint-brush" aria-hidden="true"></i> <?php _e('Color','word-balloon'); ?></label>
			<div>
				<input type="text" name="name_color" class="w_b_color_pick" data-color_change_type="name_color" data-default_color="<?php echo $load_setting['name_color']; ?>" value="<?php echo $load_setting['name_color']; ?>" />
			</div>
		</div>
	</div>
</div>

<div class="w_b_status_contents w_b_option_contents w_b_flex_box w_b_flex_column<?php echo ($load_setting['easy_mode_hidden']['status'] === 'true' ? ' w_b_easy_mode' : ''); ?>">
	<span class="w_b_contents_title"><i class="wb-commenting-o" aria-hidden="true"></i> <?php _e('Status','word-balloon'); ?></span>
	<div class="w_b_flex_box">
		<div class="w_b_status_sub_contents w_b_flex_box w_b_ai_c">
			<label class="w_b_contents_side_heading" for="w_b_status_comment"><?php _e('Comment','word-balloon'); ?></label>
			<input id="w_b_status_comment" type="text" name="status" class="" style="width: 100%;">
		</div>

		<div class="w_b_status_sub_contents w_b_flex_box w_b_ai_c w_b_jc_fe" style="margin-right: 0;">
			<label class="w_b_contents_side_heading"><i class="wb-paint-brush" aria-hidden="true"></i> <?php _e('Color','word-balloon'); ?></label>

			<input type="text" name="status_color" class="w_b_color_pick" data-color_change_type="status_color" data-default_color="<?php echo $load_setting['status_color']; ?>" value="<?php echo $load_setting['status_color']; ?>" />
		</div>
	</div>

	<?php
	if($load_setting['enable_sound'] === 'true'): ?>

		<div class="w_b_flex_box">

			<div class="w_b_status_sub_contents w_b_flex_box w_b_ai_c">
				<label class="w_b_contents_side_heading" for="w_b_status_sound"><i class="wb-volume-up" aria-hidden="true"></i> <?php _e('Sound','word-balloon'); ?></label>
				<button type="button" id="w_b_status_sound" class="w_b_status_sound_button"><?php _e('Select','word-balloon'); ?></button>
				<input id="w_b_status_sound_filename" type="text" name="status_sound_filename" class="" style="margin:0 10px;" readonly>
				<input id="w_b_status_sound_url" type="hidden" name="status_sound_url">
				<input id="w_b_status_sound_id" type="hidden" name="status_sound_id">
				<input id="w_b_status_sound_icon" type="hidden" name="status_sound_icon" data-speaker="<?php echo WORD_BALLOON_URI?>img/speaker.svg" data-play="<?php echo WORD_BALLOON_URI?>img/play.svg" data-stop="<?php echo WORD_BALLOON_URI?>img/stop.svg">
				<button type="button" id="w_b_status_sound_clear" class="w_b_status_sound_clear_button"><?php _e('Clear','word-balloon'); ?></button>
			</div>

		</div>

	<?php endif; ?>
	<input id="w_b_enable_sound" type="hidden" name="enable_sound" data-enable_sound="<?php echo $load_setting['enable_sound'] ?>" >
</div>










</form>
</div>
</div>
</div>


<div id="w_b_insert_dialog"><i class="wb-check" aria-hidden="true" style="margin-right:5px;"></i> <?php _e('Insert was successful!','word-balloon'); ?></div>
<div id="w_b_restore_dialog"><i class="wb-check" aria-hidden="true" style="margin-right:5px;"></i> <?php _e('Restore was successful!','word-balloon'); ?></div>
<input type="hidden" id="w_b_restore" data-enable="false" data-id="" data-avatar_select="" data-avatar_position="" data-avatar_size="" data-choice_balloon="" data-name_position="" data-name="" data-avatar_border_radius="" data-avatar_border="" data-avatar_shadow="" data-balloon_shadow="" data-font_color="" data-balloon_background="" data-avatar_effect="" data-balloon_effect="" data-icon_effect="" data-icon_type="" data-icon_position="" data-icon_size="" data-icon_flip_h="" data-icon_flip_v="" data-avatar_flip_h="" data-avatar_flip_v="" data-src="" data-border_style="" data-border_width="" data-border_color="" data-name_color="" data-status="" data-status_color="" data-avatar_hide="" data-font_size="" data-sound="" data-box_center="" data-text_align="" data-balloon_shadow_color="" data-balloon_full_width="" data-avatar_filter="" data-icon_filter="" data-balloon_filter="" data-status_sound_filename="" data-status_sound_id="" data-status_sound_url="" data-balloon_quote="" />
<input type="hidden" id="w_b_restore_copy" />
<style type="text/css" id="w_b_post_page"></style>





</div>


<?php
}

