<?php
defined( 'ABSPATH' ) || exit;

add_shortcode('word_balloon', 'word_balloon_shortcode');

function word_balloon_shortcode( $atts , $content = null ){
	global $wpdb;
	$table_name = $wpdb->prefix . 'word_balloon';
	$array = $wpdb->get_results("SELECT * FROM $table_name", 'ARRAY_A');

	
	require_once WORD_BALLOON_DIR . 'inc/default_settings.php';

	$atts = shortcode_atts(word_balloon_default_settings('atts'),$atts,'word_balloon');

	
	$content = do_shortcode( shortcode_unautop( $content ) );

	add_action( 'wp_footer', 'word_balloon_user_styles');

	return word_balloon_build_balloon( $atts , $array , $content , '');

}

function word_balloon_build_balloon( $atts , $array , $content , $textarea){

	$load_setting = word_balloon_default_settings('load_setting');
	
	wp_enqueue_style('word_balloon_skin_'.$atts['balloon'], WORD_BALLOON_URI . 'css/skin/word_balloon_'.$atts['balloon'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);

	if(defined('WORD_BALLOON_AMP')){
		if(WORD_BALLOON_AMP){
			if($atts['balloon'] != 'talk' && $atts['balloon'] != 'think'){
				$atts['balloon'] = $load_setting['amp_balloon'];
			}
			$atts['balloon_effect'] = $atts['avatar_effect'] = $atts['icon_type'] = $atts['icon_effect'] = $atts['sound'] = '';
		}
	}


	if($load_setting['inview'] === 'true' && !is_admin() ){
		wp_enqueue_style( 'word_balloon_inview_style', WORD_BALLOON_URI . 'css/word_balloon_inview.min.css' , array() , WORD_BALLOON_VERSION);
		wp_enqueue_script( 'polyfill_IntersectionObserver', 'https://polyfill.io/v2/polyfill.min.js?features=IntersectionObserver', array(), null , true );
		wp_enqueue_script('word_balloon_inview_script', WORD_BALLOON_URI . 'js/word_balloon_inview.js',array('polyfill_IntersectionObserver'),WORD_BALLOON_VERSION,true);
	}

	$box_padding_top = $background_style = $flex_end = $flex_center = '';

	if($atts['id'] === 'mystery_men'){
		$atts['src'] = WORD_BALLOON_URI . 'img/mystery_men.svg';
		if($atts['name'] === 'false'){
			$atts['name'] = '';
		}elseif($atts['name'] === ''){
			$atts['name'] = __('Mystery Men','word-balloon');
		}
	}elseif($atts['id'] === 'unset'){
		if($atts['name'] === 'false'){
			$atts['name'] = '';
		}
	}else{
		foreach($array as $key => $value){
			if($value['id'] === $atts['id']){
				$atts['src'] = $value['url'];
				if($atts['name'] === 'false'){
					$atts['name'] = '';
				}elseif($atts['name'] === ''){
					$atts['name'] = $value['name'];
				}
			}
		}
	}

	$full_width = '';
	if($atts['balloon_full_width'] != 'false'){
		$full_width = ' w_b_w100';
	}

	$margin_left_auto = ' w_b_mla';
	if($atts['box_center'] === 'true'){
		$flex_center .= ' w_b_jc_c w_b_mla w_b_mra';
		$margin_left_auto = '';
	}

	if($atts['balloon'] === 'rpg_3'){
		if($atts['position'] === 'L') $flex_end .= ' w_b_ml14';
		if($atts['position'] === 'R') $flex_end .= ' w_b_mr14';
	}

	if($atts['position'] === 'L') {
		$flex_center .= ' w_b_mra';
	}

	if($atts['position'] === 'R') {
		$flex_end .= ' w_b_jc_fe'.$margin_left_auto;
		$flex_center .= ' w_b_mla';
	}


	if($atts['balloon'] === 'upper' || $atts['balloon'] === 'lower'){
		if($atts['position'] === 'L') $flex_end = ' w_b_col w_b_ai_fs';
		if($atts['position'] === 'R') $flex_end = ' w_b_col w_b_ai_fe'.$margin_left_auto;
		if($atts['position'] === 'R' && $atts['box_center'] === 'true') $flex_end = ' w_b_col w_b_ai_fe';
	}



	$msg = '<div class="w_b_box w_b_flex'.$flex_center.'">';
	$msg .= '<div class="w_b_wrap w_b_flex'.$flex_end.$full_width.'">';



	if( ($atts['position'] === 'L' && $atts['balloon'] != 'upper') || $atts['balloon'] === 'lower' ){
		$msg .= word_balloon_build_avater_box( $atts );

		$msg .= word_balloon_build_balloon_box( $atts , $content , $textarea );

	}else{

		$msg .= word_balloon_build_balloon_box( $atts , $content , $textarea );

		$msg .= word_balloon_build_avater_box( $atts );
	}



	$msg .= '</div></div>';

	return $msg;

}

function word_balloon_build_avater_box( $atts ){

	
	require_once WORD_BALLOON_DIR . 'inc/default_settings.php';
	$load_setting = word_balloon_default_settings('load_setting');

	if($atts['avatar_hide'] === 'true' && !is_admin()){
		$msg = '';
		if($atts['balloon'] === 'think'){
			$msg =  '<div class="w_b_ava_box"><div class="w_b_space">'."\n".'<img src="'. WORD_BALLOON_URI .'img/blank.png" height="28" width="28" class="w_b_blank" layout="fixed" decoding="async" />'."\n".'</div></div>';
		}

	}else{




		$flex_to_end = $radius = $avatar_size = $avatar_size_width = $avatar_size_height = $msg = $mta = $flip = $name_color = $name_box = $ava_style = $avatar_filter = $border = $avatar_shadow = $avatar_flip = $icon_filter = '';

		$allowed_tag = array(
			'br' => array(),
		);


		
		if($atts['balloon'] === 'think' || $atts['balloon'] === 'tail' || $atts['balloon'] === 'soi' || $atts['balloon'] === 'wriggle' || $atts['balloon'] === 'freehand' || $atts['balloon'] === '8bit' || $atts['balloon'] === 'tail_2' || $atts['balloon'] === 'scream'){
			$flex_to_end = ' w_b_mta w_b_flex w_b_col w_b_jc_fe';
		}elseif($atts['balloon'] === 'round' || $atts['balloon'] === 'round_2'){
			$mta = ' w_b_mta w_b_flex w_b_col w_b_jc_fe';
		}

		
		if($atts['balloon'] === 'rpg_3'){
			$ava_style = 16;
			if($atts['name_position'] === 'on_balloon')$ava_style = 32;
			$ava_style = ' style="margin-top:'.$ava_style.'px;"';
		}

		$avatar_size_width = $load_setting['avatar_custom_size'][$atts['size']];
		$avatar_size_height = $load_setting['avatar_custom_size'][$atts['size']];
/*
		$avatar_size = attachment_url_to_postid($atts['src']);
		if($avatar_size){
			$avatar_size = wp_get_attachment_metadata($avatar_size);
			$avatar_size_width = $avatar_size['width'];
			$avatar_size_height =  $avatar_size['height'];
		}else{

			$avatar_size_width = $load_setting['avatar_custom_size'][$atts['size']];
			$avatar_size_height = $load_setting['avatar_custom_size'][$atts['size']];
		}
*/
		/*switch($atts['size']){
			case 'S' : $avatar_size_num = $load_setting['avatar_custom_size']['S'];  break;
			case 'M' : $avatar_size_num = $load_setting['avatar_custom_size']['M'];  break;
			case 'L' : $avatar_size_num = $load_setting['avatar_custom_size']['L']; break;
			default : ;
		}*/

		if($atts['name_color'] != ''){
			$name_color = ' style="color:'.$atts['name_color'].';"';
		}

		if($atts['name'] != ''){
			$name_box = '<div class="w_b_name w_b_name_C w_b_ta_C"'.$name_color.'>'.wp_kses( $atts['name'], $allowed_tag ).'</div>';
		}

		
		if($atts['avatar_filter'] != ''){
			if ( in_array( $atts['avatar_filter'], array_keys($load_setting['type_filter']) ) ) {
				wp_enqueue_style('word_balloon_filter_'.$atts['avatar_filter'], WORD_BALLOON_URI . 'css/filter/word_balloon_'.$atts['avatar_filter'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
				$avatar_filter = ' w_b_f_'.$atts['avatar_filter'];
			}
		}




		
		$effect = '';
		if($atts['avatar_effect'] != '' ){
			if ( in_array( $atts['avatar_effect'], array_keys($load_setting['type_effect']) ) ) {
				$effect = ' w_b_'.$atts['avatar_effect'];
				wp_enqueue_style('word_balloon_effect_'.$atts['avatar_effect'], WORD_BALLOON_URI . 'css/effect/word_balloon_'.$atts['avatar_effect'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
			}
		}

		$msg = '<div class="w_b_ava_box w_b_ava_'.$atts['position'].$mta.$flex_to_end.' w_b_f_n"'.$ava_style.'>';




		if($atts['name_position'] === 'on_avatar'){
			$msg .= $name_box;
		}

		
		if($atts['avatar_border'] != 'false') $border = ' w_b_border_'.$atts['position'];

		
		if($atts['avatar_shadow'] != 'false'){
			$avatar_shadow = ' w_b_ava_shadow_'.$atts['position'];
		}

		
		if($atts['radius'] != 'false'){
			switch($atts['radius']){
				case 'radius_3' : $radius = " w_b_radius_3"; break;
				case 'radius_12' : $radius = " w_b_radius_12"; break;
				case 'radius_20' : $radius = " w_b_radius_20"; break;
				case 'true' : $radius = " w_b_radius"; break;
				default : break;
			}
		}

		
		if($atts['avatar_flip'] != '') {
			$avatar_flip = ' w_b_flip_'.$atts['avatar_flip'];
		}

		$msg .= '<div class="w_b_icon_wrap">';

		
		$icon_effect = ''; $icon_position = $icon_flip = $icon_size = '';
		if($atts['icon_type'] != '' ) {

			wp_enqueue_style('word_balloon_icon', WORD_BALLOON_URI . 'css/word_balloon_icon.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
			if($atts['icon_effect'] != '' ){
				if ( in_array( $atts['icon_effect'], array_keys($load_setting['type_effect']) ) ) {
					$icon_effect = ' w_b_'.$atts['icon_effect'];
					wp_enqueue_style('word_balloon_effect_'.$atts['icon_effect'], WORD_BALLOON_URI . 'css/effect/word_balloon_'.$atts['icon_effect'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
				}
			}

			if($atts['icon_filter'] != ''){
				if ( in_array( $atts['icon_filter'], array_keys($load_setting['type_filter']) ) ) {
					wp_enqueue_style('word_balloon_filter_'.$atts['icon_filter'], WORD_BALLOON_URI . 'css/filter/word_balloon_'.$atts['icon_filter'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
					$icon_filter = ' w_b_f_'.$atts['icon_filter'];
				}
			}

			if($atts['icon_position'] === "top_left" || $atts['icon_position'] === "bottom_left" || $atts['icon_position'] === "center_left"){
				$icon_position .= ' w_b_icon_L';
			}
			if($atts['icon_position'] === "top_right" || $atts['icon_position'] === "bottom_right" || $atts['icon_position'] === "center_right"){
				$icon_position .= ' w_b_icon_R';
			}
			if($atts['icon_position'] === "top_left" || $atts['icon_position'] === "top_right" || $atts['icon_position'] === "top_center"){
				$icon_position .= ' w_b_icon_T';
			}
			if($atts['icon_position'] === "bottom_left" || $atts['icon_position'] === "bottom_right" || $atts['icon_position'] === "bottom_center"){
				$icon_position .= ' w_b_icon_B';
			}
			if($atts['icon_position'] === "top_center" || $atts['icon_position'] === "bottom_center" || $atts['icon_position'] === "center"){
				$icon_position .= ' w_b_icon_HC';
			}
			if($atts['icon_position'] === "center_left" || $atts['icon_position'] === "center_right" || $atts['icon_position'] === "center"){
				$icon_position .= ' w_b_icon_VC';
			}


			if($atts['icon_flip'] != '') {
				$icon_flip = ' w_b_flip_'.$atts['icon_flip'];
			}

			if($atts['icon_size'] != '') {
				$icon_size = ' w_b_icon-'.$atts['icon_size'];
			}

			$msg .= '<div class="w_b_icon'.$icon_size.$icon_position.$icon_effect.'">'."\n".'<img src="'. WORD_BALLOON_URI .'icon/'.$atts['icon_type'].'.svg" class="w_b_icon_'.$atts['icon_type'].$icon_flip.$icon_filter.'" decoding="async" />'."\n".'</div>';
		}




		$msg .= '<div class="w_b_ava_wrap w_b_size_'.$atts['size'].$radius.$border.$avatar_shadow.$effect.'">';


		$msg .= "\n".'<img src="' .$atts['src']. '" width="'.$avatar_size_width.'" height="'.$avatar_size_height.'" alt="'.$atts['name'].'" layout="fixed" class="w_b_ava_img '.$avatar_flip.$avatar_filter.'" decoding="async" />'."\n";

		$msg .= '</div></div>';

		if($atts['name_position'] === 'under_avatar' && $atts['name'] != ''){
			$msg .= $name_box;
		}

		$msg .= '</div>';
	}
	return $msg;

}



function word_balloon_build_balloon_box( $atts , $content , $textarea ){

	
	require_once WORD_BALLOON_DIR . 'inc/default_settings.php';
	$load_setting = word_balloon_default_settings('load_setting');

	
	require_once WORD_BALLOON_DIR . 'inc/adjust_balloon.php';


	$msg = '';

	$allowed_tag = array(
		'br' => array(),
	);

	$balloon_data_name = array('balloon_shadow','box_padding_top','box_padding_bottom','box_padding','text_color','background_color','background_style','border_style','mta','name_color','name_box','status_color','status_box','font_size','name_position','up_down','sound','flip','etc_style','text_align','name_style','full_width','balloon_filter','effect','name_margin','border_image_source','quote_align');

	foreach ($balloon_data_name as $key) {
		$balloon_data[$key] = '';
	}

	$balloon_data['name_margin'] = 16;


	if($atts['text_align'] != ''){
		if($atts['balloon_full_width'] != 'false'){
			if($atts['text_align'] === 'R'){
				$balloon_data['text_align'] = ' w_b_jc_fe';
			}elseif($atts['text_align'] === 'C'){
				$balloon_data['text_align'] = ' w_b_jc_c';
			}
		}else{
			$balloon_data['text_align'] = ' w_b_ta_'.$atts['text_align'];
		}
	}

	
	if($atts['sound'] != ''){
		$balloon_data['sound'] = wp_get_attachment_url($atts['sound']);
		if($balloon_data['sound']){
			if($atts['position'] === 'R')$balloon_data['flip'] = ' w_b_flip_h';
			$balloon_data['sound'] = '<div class="w_b_sound" style="cursor:pointer;"><div class="w_b_play_sound" data-audio_id="'.$atts['sound'].'" data-audio_url="'.$balloon_data['sound'].'" data-play="'. WORD_BALLOON_URI .'img/play.svg" data-speaker="'. WORD_BALLOON_URI .'img/speaker.svg" data-flip="'.$balloon_data['flip'].'" >'."\n".'<img src="'. WORD_BALLOON_URI .'img/speaker.svg" width="26" height="26" class="'.$balloon_data['flip'].'" decoding="async" />'."\n".'</div><div class="w_b_stop_sound" data-audio_id="'.$atts['sound'].'" style="display:none">'."\n".'<img src="'. WORD_BALLOON_URI .'img/stop.svg" width="26" height="26" decoding="async" />'."\n".'</div></div>';
			wp_enqueue_script( 'word_balloon_sound_script', WORD_BALLOON_URI . 'js/word_balloon_sound.min.js', array('jquery'), WORD_BALLOON_VERSION,true );
		}
	}

	
	if($atts['balloon_filter'] != ''){
		if ( in_array( $atts['balloon_filter'], array_keys($load_setting['type_filter']) ) ) {
			wp_enqueue_style('word_balloon_filter_'.$atts['balloon_filter'], WORD_BALLOON_URI . 'css/filter/word_balloon_'.$atts['balloon_filter'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
			$balloon_data['balloon_filter'] = ' w_b_f_'.$atts['balloon_filter'];
		}
	}

	if($atts['balloon_full_width'] != 'false'){
		$balloon_data['full_width'] = ' w_b_w100';
	}

	if($atts['font_size'] != ''){
		$balloon_data['font_size'] = 'font-size:'.$atts['font_size'].'px;';
	}



	
	$function_balloon = 'word_balloon_adjust_balloon_'.$atts['balloon'];
	if ( function_exists( $function_balloon ) ){
		$balloon_data = $function_balloon($atts , $load_setting , $balloon_data);
	}






	if($balloon_data['background_color'] || $balloon_data['text_color'] || $balloon_data['font_size'] || $balloon_data['etc_style'] || $balloon_data['border_style'] || $balloon_data['border_image_source']){
		$balloon_data['background_style'] = ' style="' .$balloon_data['background_color'].$balloon_data['border_style'].$balloon_data['text_color'].$balloon_data['font_size'] .$balloon_data['etc_style']. $balloon_data['border_image_source'] .'"';
	}

	
	if( $atts['name_position'] === 'on_balloon' ||  $atts['name_position'] === 'under_balloon' ){

		if($atts['name'] != ''){
			$name_side_margin = '';

			$balloon_data['name_position'] = $atts['position'];

			if($atts['name_color'] != ''){
				$balloon_data['name_style'] .= 'color:'.$atts['name_color'].';';
			}

			if($atts['position'] === 'R'){
				$balloon_data['name_position'] = 'L';
			}else{
				$balloon_data['name_position'] = 'R';
			}

			
			if( $atts['balloon'] === 'lower' ){
				if($atts['name_position'] === 'under_balloon'){
					$balloon_data['name_style'] .= $balloon_data['etc_style'];
				}
			}


			if( $atts['name_position'] === 'on_balloon'){

				if( $atts['balloon'] === 'upper' ){
					$balloon_data['name_style'] .= $balloon_data['etc_style'];
				}

				if( $atts['balloon'] === 'line' ){
					if($atts['position'] === 'R'){
						$balloon_data['name_position'] = 'R';
					}else{
						$balloon_data['name_position'] = 'L';
					}
					$name_side_margin = 14;
				}

				/*switch($atts['balloon']){
					case 'talk' : $name_side_margin = 15;  break;
					case 'think' : $name_side_margin = -10;  break;
					case 'line' : $name_side_margin = 14; break;
					case 'round' : $name_side_margin = 5;  break;
					case 'tail' : $name_side_margin = 10;  break;
					case 'bump' : $name_side_margin = 10; break;
					case 'soi' : $name_side_margin = 12; break;
					case 'rpg_1' : $name_side_margin = 8;  break;
					case 'rpg_2' : $name_side_margin = 16;  break;
					default : ;
				}*/
			}

			if($name_side_margin != ""){
				if($atts['position'] === 'R'){
					$balloon_data['name_style'] .= 'margin-right:'.$name_side_margin.'px;';
				}else{
					$balloon_data['name_style'] .= 'margin-left:'.$name_side_margin.'px;';
				}
			}


			if( $atts['balloon'] === 'rpg_3' && ($atts['name_position'] === 'on_balloon' || $atts['balloon'] === 'under_balloon' ) ){
				$balloon_data['name_position'] .= ' w_b_ta_R';
			}

			if($balloon_data['name_style'] != ''){
				$balloon_data['name_style'] = ' style="'.$balloon_data['name_style'].'"';
			}

			$balloon_data['name_box'] = '<div class="w_b_name w_b_name_'.$balloon_data['name_position'].' w_b_ta_'.$balloon_data['name_position'].'"'.$balloon_data['name_style'].'>'.wp_kses( $atts['name'], $allowed_tag ).'</div>';
		}

	}


	

	if($atts['balloon_effect'] != '' ){
		if ( in_array( $atts['balloon_effect'], array_keys($load_setting['type_effect']) ) ) {
			$balloon_data['effect'] = ' w_b_'.$atts['balloon_effect'];
			wp_enqueue_style('word_balloon_effect_'.$atts['balloon_effect'], WORD_BALLOON_URI . 'css/effect/word_balloon_'.$atts['balloon_effect'].'.min.css',array('word_balloon_user_style'),WORD_BALLOON_VERSION);
		}
	}

	if($balloon_data['box_padding_top'] != ""){

		$balloon_data['box_padding'] = '<div class="w_b_space">'."\n".'<img src="'. WORD_BALLOON_URI .'img/blank.png" height="'.$balloon_data['box_padding_top'].'" width="'.$balloon_data['box_padding_top'].'" class="w_b_blank" layout="fixed" decoding="async" />'."\n".'</div>';
	}

	
	if($atts['balloon_shadow'] != 'false'){
		if($atts['balloon'] !== 'rpg_1' && $atts['balloon'] !== 'rpg_2' && $atts['balloon'] !== 'rpg_3' && $atts['balloon'] !== 'heart' && $atts['balloon'] !== 'wriggle')
			$balloon_data['balloon_shadow'] = ' w_b_shadow_'.$atts['position'];
	}


	
	if($atts['status'] != '' || $atts['sound'] != ''){
		if($atts['status_color'] != '') $balloon_data['status_color'] = ' style="color:'.$atts['status_color'].';"';
		$balloon_data['status_box'] .= '<div class="w_b_status_box w_b_flex w_b_col w_b_f_n">';

		$balloon_data['status_box'] .= '<div class="w_b_status_sound">'.$balloon_data['sound'].'</div>';

		$balloon_data['status_box'] .= '<div class="w_b_status w_b_flex w_b_col w_b_jc_fe"'.$balloon_data['status_color'].'>';
		$balloon_data['status_box'] .= wp_kses( $atts['status'], $allowed_tag );
		$balloon_data['status_box'] .= '</div>';

		$balloon_data['status_box'] .= '</div>';

	}



	$msg .= '<div class="w_b_bal_box w_b_w100'.$balloon_data['mta'].$balloon_data['effect'].'">'.$balloon_data['box_padding'];


	$msg .= '<div class="w_b_flex'.$balloon_data['full_width'].'">';

	if($atts['position'] === 'R')$msg .= $balloon_data['status_box'];

	$msg .= '<div class="w_b_bal_wrap w_b_bal_wrap_'.$atts['position'].$balloon_data['full_width'].'">';

	if($atts['name_position'] === 'on_balloon'){
		$msg .= $balloon_data['name_box'];
	}

	if($balloon_data['full_width'] === ' w_b_w100'){
		$balloon_data['full_width'] = ' w_b_flex';
	}

	$msg .= '<div class="w_b_bal w_b_'.$atts['balloon'].' w_b_bal_'.$atts['position'].' w_b_'.$atts['balloon'].'_'.$atts['position'].$balloon_data['balloon_shadow'].$balloon_data['up_down'].$balloon_data['text_align'].$balloon_data['full_width'].$balloon_data['balloon_filter'].$balloon_data['quote_align'].'"'.$balloon_data['background_style'].'><div>'.$content.$textarea.'</div></div>';

	if($atts['name_position'] === 'under_balloon'){
		$msg .= $balloon_data['name_box'];
	}

	$msg .= '</div>';


	if($atts['position'] === 'L')$msg .= $balloon_data['status_box'];

	$msg .= '</div>';




	if($balloon_data['box_padding_bottom'] != ""){
		$msg .= '<div class="w_b_space">'."\n".'<img src="'. WORD_BALLOON_URI .'img/blank.png" height="'.$balloon_data['box_padding_bottom'].'" width="'.$balloon_data['box_padding_bottom'].'" class="w_b_blank" layout="fixed" decoding="async" />'."\n".'</div>';
	}

	$msg .= '</div>';

	return $msg;

}

add_shortcode('word_balloon_wallpaper', 'word_balloon_shortcode_wallpaper');

function word_balloon_shortcode_wallpaper( $atts, $content = null ) {
	$style = $style_background_color = $style_image = $style_border = $border_radius = '';
	if(isset($atts['id'])){
		
		require_once WORD_BALLOON_DIR . 'inc/default_settings.php';
		$load_setting = word_balloon_default_settings('load_setting');
		if( isset( $load_setting['wallpaper'][$atts['id']]["image"] ) ){
			if($load_setting['wallpaper'][$atts['id']]["image"] != '')
				$style_image = 'background-image:url('.esc_url($load_setting['wallpaper'][$atts['id']]["image"]).');';
		}
		if( isset( $load_setting['wallpaper'][$atts['id']]["background_color"] ) ){
			$style_background_color = 'background-color:'.$load_setting['wallpaper'][$atts['id']]["background_color"].';';
		}
		if( isset( $load_setting['wallpaper'][$atts['id']]["border_style"] ) ){
			if($load_setting['wallpaper'][$atts['id']]["border_style"]!='none'){
				$style_border = 'border:'.$load_setting['wallpaper'][$atts['id']]["border_style"].' '.$load_setting['wallpaper'][$atts['id']]["border_width"].'px '.$load_setting['wallpaper'][$atts['id']]["border_color"].';';
			}
		}
		if( isset( $load_setting['wallpaper'][$atts['id']]["border_radius"] ) ){
			if($load_setting['wallpaper'][$atts['id']]["border_radius"]!=0){
				$border_radius = 'border-radius:'.$load_setting['wallpaper'][$atts['id']]["border_radius"].'px;';
			}
		}

		if($style_image || $style_background_color){
			$style = ' style="'.$style_image.$style_background_color.$style_border.$border_radius.'padding:20px 5px;"';
		}
	}
	$content = do_shortcode( shortcode_unautop( $content ) );
	return '<div class="w_b_wallpaper"'.$style.'>' . $content . '</div>';
}

add_shortcode('word_balloon_side_by_side', 'word_balloon_shortcode_side_by_side');

function word_balloon_shortcode_side_by_side( $atts, $content = null ) {
	$content = do_shortcode( shortcode_unautop( $content ) );
	
	
	
	
	//$content = str_replace( '</p>'."\n".'<p>','',$content);

	return '<div class="w_b_line_up w_b_box w_b_flex w_b_jc_sb w_b_f_wrap w_b_ai_c">' . $content . '</div>';
}

function word_balloon_linebreak_fix($content) {
	$array = array (
		'<br />'."\n".'[word_balloon' => '[word_balloon',
		'<br>'."\n".'[word_balloon' => '[word_balloon',
		'<br />'."\n".'[/word_balloon' => '[/word_balloon',
		'<br>'."\n".'[/word_balloon' => '[/word_balloon',
	);

	$content = strtr($content, $array);
	return $content;
}
add_filter('the_content', 'word_balloon_linebreak_fix');


function word_balloon_amp_buffer_callback ( $buffer ) {

	if(preg_match('{<html(.*?)(amp|⚡)(.*?)>}', $buffer)){

		$pattern = '{<style(.*?)amp-custom(.*?)>(.*?)</style>}is';
		$match = array();
		$judge = preg_match($pattern, $buffer, $match);

		if($judge && isset($match[3])){

			if(strlen($match[3]) < 46000){
				require_once ABSPATH . 'wp-admin/includes/file.php';
				WP_Filesystem();
				global $wp_filesystem;
				
				$amp_word_balloon = $wp_filesystem->get_contents( WORD_BALLOON_DIR.'css/word_balloon_amp.min.css' );

				$amp_file_size = strlen($amp_word_balloon) + strlen($match[3]);
				if($amp_file_size < 50000){
					
					$buffer = preg_replace($pattern, '<style$1amp-custom$2>$3'.$amp_word_balloon.'</style>', $buffer);
				}
			}
		}

	}
	return $buffer;
}

function word_balloon_amp_buffer_start() {
	ob_start('word_balloon_amp_buffer_callback');
}


function word_balloon_amp_buffer_finish() {
	ob_end_flush();
}

function word_balloon_amp_enable() {

	
	require_once WORD_BALLOON_DIR . 'inc/default_settings.php';
	$load_setting = word_balloon_default_settings('load_setting');

	if($load_setting['amp_enable'] === 'true'){

		require_once ABSPATH . 'wp-admin/includes/plugin.php';

		if(is_plugin_active( 'word-balloon-pro/word-balloon-pro.php' )) {
			$amp_url = $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];
			if('/amp/' === substr($amp_url, -5) || '?amp=1' === substr($amp_url, -6)){
				define( 'WORD_BALLOON_AMP', true );
				add_action('after_setup_theme', 'word_balloon_amp_buffer_start');
				add_action('wp_head', 'word_balloon_amp_buffer_finish');
				return;
			}
		}

	}

	define( 'WORD_BALLOON_AMP', false );
}
add_action( 'plugins_loaded', 'word_balloon_amp_enable');
